package organization;

import govtAgency.Agency;

import java.util.List;
import java.util.logging.Logger;

import person.Individual;
import person.Person;
import address.Address;

/**
 * Below is the very simple sample to design an employee
 * type class. Note the kind of attributes used
 * @author Nitin
 *
 */
public class Employee {

	private Logger LOGGER = Logger.getLogger("LOGGER");
	private Person individual;
	private Long empID;
	private String empName;
	private List<Employee> colleagues;
	private List<Employee> reportees;
	private boolean isActive;

	public Person getIndividual(String identifier){
		//		Based on the identifier provided by the individual
		//		organization will fetch the individual object from the 
		//		govt agencies
		this.individual = new Agency().getIndividual(identifier);
		return individual;
	}
	private boolean checkPossibility() {
		if(individual.isAlive()){
			return true;
		}
		return false;
	}

	public boolean isActive() {
		return isActive;
	}

	private void setIsActive(boolean status) {
		isActive = status;
	}

	public Long getEmpID() {
		return empID;
	}

	private void setEmpID(Long empID) {
		this.empID = empID;
	}

	public void setName(String identifier, String name) throws Exception {
//		Ideally this if() must be removed & getIndividual() must be called
//		every time this setName() is used to check the current validity.
//		But have used this if() because mocked object was getting overriden
//		as have not mocked Agent object
		if(individual == null){
			getIndividual(identifier);
		}
		if(checkPossibility()){
			setIsActive(true);
			this.empName = name;
		}
		else
			throw new Exception("Given person can't be made an active employee here!!!");
	}

	public String getName() {
		return empName;
	}

	public Address getAddress() {
		LOGGER.info("Got the address " + individual.getAddress().getState());
		return individual.getAddress();
	}

	public List<Person> getPersons(Address address) {
		for(Person person : address.getPersons()){
			System.out.println(person.getName());
		}
		return address.getPersons();
	}

	public boolean verifyAddress(Address address, Person person) {
		if(individual == null){
//			getIndividual(identifier)
		}
		if(individual.getAddress().getPersons().contains(person)
				&& individual.getAddress().equals(address)){
			return true;
		}
		return false;
	}

	public List<Employee> getColleagues() {
		return colleagues;
	}

	public void setColleagues(List<Employee> colleagues) {
		this.colleagues = colleagues;
	}

	public List<Employee> getReportees() {
		return reportees;
	}

	public void setReportees(List<Employee> reportees) {
		this.reportees = reportees;
	}

	@Override
	public int hashCode(){
		return this.empID.hashCode();
	}

	@Override
	public boolean equals(Object obj){
		if(obj instanceof Employee){
			Employee employee = (Employee)obj;
			if(this.empID.equals(employee.getEmpID())){
				return true;
			}
		}
		return false;
	}
}
