package person;

import java.util.List;

import address.Address;

public class Individual implements Person {

	private String identifier;
	private String name;
	private Address address;
	private boolean isAlive;
	
	@Override
	public boolean isAlive() {
		return isAlive;
	}

	public void setAlive(boolean isAlive) {
		this.isAlive = isAlive;
	}

	@Override
	public String getIdentifier() {
		return identifier;
	}

	public void setIdentifier(String identifier) {
		this.identifier = identifier;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public void setAddress(Address address) {
		this.address = address;
	}

	@Override
	public Address getAddress() {
		return address;
	}

	@Override
	public List<Person> getPersons(Address address) {
		return address.getPersons();
	}

	@Override
	public boolean verifyAddress(Address address, String id, String name) {
		List<Person> list = address.getPersons();
		for(Person person : list){
			if(person.getIdentifier().equalsIgnoreCase(id)
					&& person.getName().equalsIgnoreCase(name)){
				return true;
			}
		}
		return false;
	}
	
	@Override
	public int hashCode(){
		return this.identifier.hashCode();
	}

	@Override
	public boolean equals(Object obj){
		if(obj instanceof Individual){
			Individual individual = (Individual)obj;
			if(this.identifier.equals(individual.getIdentifier())){
				return true;
			}
		}
		return false;
	}
}
